var svg;
var force;
var dataNodes;
var dataLinks;
var originalNodes;
var originalLinks;
var lastNodes;
var lastLinks;

var endpoints = {};
var intersectionPlusCodes = {};
var linkCodes = [];
var linkCodesMapping = {};
var linkCodeIntersectionPlusCodeMapping = {};
var intersectionPlusCodeLinkCodeMapping = {};
var linkCodeIntersectionCodeMapping = {};
var intersectionCodeLinkCodeMapping = {};
var intersectionPlusCodesMapping = {};
var intersectionCodesMapping = {};
var nonLinkCodeIntersectionCodeMapping = {};
var intersectionCodeNonLinkCodeMapping = {};

var highlightNodes = false;
var reorganized = true;

function resetAll() {
    endpoints = {};
    intersectionPlusCodes = {};
    linkCodes = [];
    linkCodesMapping = {};
    linkCodeIntersectionPlusCodeMapping = {};
    intersectionPlusCodeLinkCodeMapping = {};
    linkCodeIntersectionCodeMapping = {};
    intersectionCodeLinkCodeMapping = {};
    intersectionPlusCodesMapping = {};
    intersectionCodesMapping = {};
    nonLinkCodeIntersectionCodeMapping = {};
    intersectionCodeNonLinkCodeMapping = {};
}

function prepareStructure() {
	svg.selectAll(".node").each(
		function(n) {
            var neighbours = [];
			counter = 0;
			svg.selectAll(".link").each(
				function(l) {
					if (l.source.index == n.index) {
						if (neighbours.indexOf(l.target.index) == -1) {
							neighbours.push(l.target.index);
                        }
                        counter++;
					}
					if (l.target.index == n.index) {
						if (neighbours.indexOf(l.source.index) == -1) {
                            neighbours.push(l.source.index);
                        }
					}
				}
			);
			if (counter == 0) {
				n.endpoint = true;
			} else {
				n.endpoint = false;
			}
			n.neighbours = neighbours;
			n.neighboursCount = neighbours.length;
			n.neighboursCode = neighbours.sort().join("");
			var neighboursPlus = neighbours.slice(0);
            neighboursPlus.push(n.index);
			n.neighboursPlus = neighboursPlus;
			n.neighboursPlusCount = neighboursPlus.length;
            n.neighboursPlusCode = neighboursPlus.sort().join("");
		}
	);
	svg.selectAll(".link").each(
		function(l) {
            var code = [l.source.index,l.target.index].sort().join("");
            if (linkCodes.indexOf(code) == -1) {
                linkCodes.push([l.source.index, l.target.index].sort().join(""));
                linkCodesMapping[[l.source.index, l.target.index].sort().join("")] = [l.source.index, l.target.index];
            }
		}
	);
	console.log("---PREPARE STRUCTURE---");
}

function analyseStructure() {
	svg.selectAll(".node").each(
		function(n) {
			//n.differences = {};
			if (!n.endpoint) {
                n.intersections = {};
                n.intersectionsPlus = {};
                svg.selectAll(".node").each(
                    function (m) {
                        var intersections = [];
                        var intersectionsPlus = [];
                        var actualLinkCode = [n.index,m.index].sort().join("");
                        /**
						 * Berechne die Intersections nur dann, wenn die Knoten unterschiedlich sind und verbunden sind
                         */
                        if (n.index != m.index  && linkCodes.indexOf(actualLinkCode) != -1) {
                            intersections = calculateIntersections(n.neighbours, m.neighbours);
                            if (intersections.length > 1) {
                                var actualIntersectionsCode = intersections.sort().join("");
                                if (linkCodeIntersectionCodeMapping[actualLinkCode] == undefined) {
                                	linkCodeIntersectionCodeMapping[actualLinkCode] = actualIntersectionsCode;
                                	if (intersectionCodeLinkCodeMapping[actualIntersectionsCode] == undefined) {
                                        intersectionCodeLinkCodeMapping[actualIntersectionsCode] = [];
									}
                                    intersectionCodeLinkCodeMapping[actualIntersectionsCode].push(actualLinkCode);
								}
								if (intersectionCodesMapping[actualIntersectionsCode] == undefined) {
                                	intersectionCodesMapping[actualIntersectionsCode] = intersections;
								}
                                //n.intersections[m.index] = {};
                                //n.intersections[m.index].intersections = intersections;
                                //n.intersections[m.index].intersectionsCount = intersections.length;
                                //n.intersections[m.index].intersectionsCode = intersections.sort().join("");
                            }
                        }
                        /**
						 * Berechne die Intersections nicht verbundener Knoten
						 * ohne Endpoints fuer "INTERMEDIATES" ("MIDDLES)
                         */
                        if (n.index != m.index  && linkCodes.indexOf(actualLinkCode) == -1 && m.endpoint == false && n.neighboursCount == 2) {
                        	linkCodes.push(actualLinkCode);
                        	linkCodesMapping[actualLinkCode] = [n.index, m.index];
                            intersections = calculateIntersections(n.neighbours, m.neighbours);
                            if (intersections.length > 1) {
                                var actualIntersectionsCode = intersections.sort().join("");
                                if (nonLinkCodeIntersectionCodeMapping[actualLinkCode] == undefined) {
                                    nonLinkCodeIntersectionCodeMapping[actualLinkCode] = actualIntersectionsCode;
                                    if (intersectionCodeNonLinkCodeMapping[actualIntersectionsCode] == undefined) {
                                        intersectionCodeNonLinkCodeMapping[actualIntersectionsCode] = [];
                                    }
                                    intersectionCodeNonLinkCodeMapping[actualIntersectionsCode].push(actualLinkCode);
                                }
                                if (intersectionCodesMapping[actualIntersectionsCode] == undefined) {
                                    intersectionCodesMapping[actualIntersectionsCode] = intersections;
                                }
                                //n.intersections[m.index] = {};
                                //n.intersections[m.index].intersections = intersections;
                                //n.intersections[m.index].intersectionsCount = intersections.length;
                                //n.intersections[m.index].intersectionsCode = intersections.sort().join("");
                            }
                        }
                        /**
						 * Berechne die IntersectionsPlus dann, wenn die Knoten unterschiedlich sind und die Verknüpfung beider in den Links vorkommt
                         */
                        if (n.index != m.index && linkCodes.indexOf(actualLinkCode) != -1) {
                            intersectionsPlus = calculateIntersections(n.neighboursPlus, m.neighboursPlus);
							if (intersectionsPlus.length > 1 && intersectionsPlus.indexOf(m.index) > -1) {
                            	var actualIntersectionsPlusCode = intersectionsPlus.sort().join("");
                            	if (linkCodeIntersectionPlusCodeMapping[actualLinkCode] == undefined) {
                                    linkCodeIntersectionPlusCodeMapping[actualLinkCode] = actualIntersectionsPlusCode;
                                    if (intersectionPlusCodeLinkCodeMapping[actualIntersectionsPlusCode] == undefined) {
                                        intersectionPlusCodeLinkCodeMapping[actualIntersectionsPlusCode] = [];
									}
                                    intersectionPlusCodeLinkCodeMapping[actualIntersectionsPlusCode].push(actualLinkCode);
                                }
                                if (intersectionPlusCodesMapping[actualIntersectionsPlusCode] == undefined) {
                                    intersectionPlusCodesMapping[actualIntersectionsPlusCode] = intersectionsPlus;
								}

                                if (n.intersectionsPlusCodes == undefined) {
                                    n.intersectionsPlusCodes = {};
                                }
                                n.intersectionsPlus[m.index] = {};
                                n.intersectionsPlus[m.index].intersections = intersectionsPlus;
                                n.intersectionsPlus[m.index].intersectionsCount = intersectionsPlus.length;
                                n.intersectionsPlus[m.index].intersectionsCode =actualIntersectionsPlusCode;
                                n.intersectionsPlusCodes[n.intersectionsPlus[m.index].intersectionsCode] = m.index;

                                if (n.intersectionsPlus[m.index].intersectionsCount > 2) {
                                    if (intersectionPlusCodes[n.intersectionsPlus[m.index].intersectionsCode] == undefined) {
                                        intersectionPlusCodes[n.intersectionsPlus[m.index].intersectionsCode] = {"points":[], "count":intersectionsPlus.length};
                                    }
                                    if (intersectionPlusCodes[n.intersectionsPlus[m.index].intersectionsCode].points.indexOf(n.index) == -1) {
                                        intersectionPlusCodes[n.intersectionsPlus[m.index].intersectionsCode].points.push(n.index);
                                    }
                                }
                            }
						}
                    }
                );
            }
		}
	);
	console.log("---ANALYSE STRUCTURE---");
}

function handleEndPoints() {
    console.log("---ENDPOINTS START---");
	var actualNeighboursCode = "";
	var endpointGroup = 0;

	svg.selectAll(".node").filter(
		function(n) {
			if (!!n.endpoint) {
				return true;
			}
			return false;
		}
	).sort(
		function(a, b) {
			return a.neighboursCode.localeCompare(b.neighboursCode);
		}
	).each(
		function(n) {
            if (endpointGroup == 0) {
            	endpointGroup++;
                actualNeighboursCode = n.neighboursCode;
                n.endpointGroup = endpointGroup;
                endpoints.groups = [];
                endpoints.groups.push(endpointGroup);
                endpoints[endpointGroup] = {};
                endpoints[endpointGroup].points = []
				endpoints[endpointGroup].points.push(n.index);
            } else {
            	if (n.neighboursCode != actualNeighboursCode) {
            		actualNeighboursCode = n.neighboursCode;
            		endpointGroup++;
            		endpoints.groups.push(endpointGroup);
                    n.endpointGroup = endpointGroup;
                    endpoints[endpointGroup] = {};
                    endpoints[endpointGroup].points = []
                    endpoints[endpointGroup].points.push(n.index);
				} else {
            		n.endpointGroup = endpointGroup;
                    endpoints[endpointGroup].points.push(n.index);
				}
			}
        }
	);
    endpoints.groups.forEach(function(g) {
        if (endpoints[g].points.length > 1) {
        	if (highlightNodes) {
                svg.selectAll(".node").filter(
                    function (n) {
                        if (n.endpointGroup == g) {
                            return true;
                        }
                        return false;
                    }
                ).select("circle").style("fill", "blue");
            } else {
                lastNodes = originalNodes;
                lastLinks = originalLinks;

                var substitutes = {};
                svg.selectAll(".node").filter(
                    function (n) {
                        if (n.endpointGroup == g) {
                            if (substitutes[g] == undefined) {
                                substitutes[g] = [];
                            }
                            substitutes[g].push(n.id);
                            return true;
                        }
                        return false;
                    }
                ).remove();

                Object.keys(substitutes).forEach(function(ep) {
                    var tmpNodes = [];
                    dataNodes.forEach(function (dataNode) {
                        if (substitutes[ep].indexOf(dataNode.id) == -1) {
                            tmpNodes.push(dataNode);
                        }
                    });
                    var tmpIndex = tmpNodes.push({"name": "EP_"+ep, "type": "arc", "id": "ep_"+ep, "size": substitutes[ep].length}) - 1;
                    dataNodes = tmpNodes;

                    var tmpLinks = [];
                    dataLinks.forEach(function (dataLink) {
                        if (endpoints[ep].points.indexOf(dataLink.source.index) == -1 && endpoints[ep].points.indexOf(dataLink.target.index) == -1) {
                            tmpLinks.push(dataLink);
                        }
                        if (endpoints[ep].points.indexOf(dataLink.source.index) > -1 && endpoints[ep].points.indexOf(dataLink.target.index) == -1) {
                            tmpLinks.push({"source":tmpIndex,"target":getNewIndexFromOriginal(dataLink.target.index),"weight":1, "value":20});
                            //tmpLinks.push(dataLink);
                        }
                        if (endpoints[ep].points.indexOf(dataLink.target.index) > -1 && endpoints[ep].points.indexOf(dataLink.source.index) == -1) {
                            tmpLinks.push({"source":getNewIndexFromOriginal(dataLink.source.index),"target":tmpIndex,"weight":1, "value":20});
                            //tmpLinks.push(dataLink);
                        }
                    });
                    dataLinks = tmpLinks;
                });

                svg.selectAll(".node").remove();
                svg.selectAll(".link").remove();
                update();

            }
		}
	});
}

function handleMiddle() {
	console.log("---START MIDDLE---");
    var middles = {};
	Object.keys(intersectionCodeNonLinkCodeMapping).forEach(function(mapping) {
		if (intersectionCodeNonLinkCodeMapping[mapping].length > 1) {
			var result = [];
            intersectionCodeNonLinkCodeMapping[mapping].forEach(function (el) {
            	//console.log(el);
				result = calculateMerge(result, linkCodesMapping[el]);
			});
            middles[result.join("")] = result;
		}
	});

	if (highlightNodes) {
        svg.selectAll(".node").filter(
            function (n) {
                var returner = false;
                Object.keys(middles).forEach(function (m) {
                    middles[m].forEach(function (el) {
                        if (n.index == el) {
                            returner = true;
                        }
                    });
                });
                return returner;
            }
        ).select("circle").style("fill", "red");
    } else {
        lastNodes = dataNodes;
        lastLinks = dataLinks;

        var substitutes = {};
        svg.selectAll(".node").filter(
            function (n) {
                var returner = false;
                Object.keys(middles).forEach(function (m) {
                    middles[m].forEach(function (el) {
                        if (n.index == el) {
                            if (substitutes[m] == undefined) {
                                substitutes[m] = [];
                            }
                            substitutes[m].push(n.id);
                            returner = true;
                        }
                    });
                });
                return returner;
            }
        ).remove();

        Object.keys(substitutes).forEach(function(middle) {
            var tmpNodes = [];
            dataNodes.forEach(function (dataNode) {
                if (substitutes[middle].indexOf(dataNode.id) == -1) {
                    tmpNodes.push(dataNode);
                }
            });
            var tmpIndex = tmpNodes.push({"name": "MIDDLE_"+middle, "type": "check", "id": "middle_" + middle, "size": substitutes[middle].length}) - 1;
            dataNodes = tmpNodes;

            var tmpLinks = [];
            dataLinks.forEach(function (dataLink) {
                if (middles[middle].indexOf(dataLink.source.index) == -1 && middles[middle].indexOf(dataLink.target.index) == -1) {
                    tmpLinks.push(dataLink);
                }
                if (middles[middle].indexOf(dataLink.source.index) > -1 && middles[middle].indexOf(dataLink.target.index) == -1) {
                    var newIndex = getNewIndexFromOriginal(dataLink.target.index);
                    if (newIndex != -1) {
                        tmpLinks.push({"source": tmpIndex, "target": newIndex, "weight": 1, "value": 20});
                    }
                    //tmpLinks.push(dataLink);
                }
                if (middles[middle].indexOf(dataLink.target.index) > -1 && middles[middle].indexOf(dataLink.source.index) == -1) {
                    var newIndex = getNewIndexFromOriginal(dataLink.source.index);
                    if (newIndex != -1) {
                        tmpLinks.push({"source": newIndex, "target":tmpIndex,"weight":1, "value":20});
                    }
                    //tmpLinks.push(dataLink);
                }
            });
            dataLinks = tmpLinks;
        });

        svg.selectAll(".node").remove();
        svg.selectAll(".link").remove();
        update();
	}
	console.log("---END MIDDLE---")
}

function handleCross() {
	console.log("---START CROSS---");
	var crosses = {};
	var crossesMapping = {};
	var foundCrosses = {};

	linkCodes.forEach(function(code) {
		//console.log(code);
		//console.log(linkCodeIntersectionPlusCodeMapping[code]);
		if (linkCodeIntersectionPlusCodeMapping[code]) {
            //console.log(intersectionPlusCodesMapping[linkCodeIntersectionPlusCodeMapping[code]]);
            var crossCode = intersectionPlusCodesMapping[linkCodeIntersectionPlusCodeMapping[code]].sort().join("");
            if (crosses[crossCode] == undefined) {
                crosses[crossCode] = [];
            }
            crosses[crossCode].push(code);
            crossesMapping[crossCode] = intersectionPlusCodesMapping[linkCodeIntersectionPlusCodeMapping[code]];
        }
	});

    Object.keys(crosses).forEach(function(cross) {
        //console.log(cross);
        //console.log(crossesMapping[cross]);
        //console.log(crosses[cross]);
        //console.log(crosses[cross].length);
		//console.log(crosses[cross].length);
		//console.log(cross.length);
		//console.log(crosses[cross].length - cross.length);
        //console.log(calculateCross(crosses[cross].length - cross.length));
        //console.log("---");
        if (cross.length == crosses[cross].length - calculateCross(crosses[cross].length - cross.length)) {
        	//console.log("FOUND");
			foundCrosses[cross] = crosses[cross];
            //console.log("CROSS FOUND");
        }
    });

    if (highlightNodes) {
        svg.selectAll(".node").filter(function (n) {
            var returner = false;
            Object.keys(foundCrosses).forEach(function (cross) {
                if (crossesMapping[cross].indexOf(n.index) != -1) {
                    returner = true;
                }
            });
            return returner;
        }).select("circle").style("fill", "violet");
    } else {
    	console.log("---SUBSTITUTES---");
        lastNodes = dataNodes;
        lastLinks = dataLinks;

        var substitutes = {};
        svg.selectAll(".node").filter(function (n) {
        	var returner = false;
            Object.keys(foundCrosses).forEach(function (cross) {
                if (crossesMapping[cross].indexOf(n.index) != -1) {
                    if (substitutes[cross] == undefined) {
                        substitutes[cross] = [];
                    }
                    substitutes[cross].push(n.id);
                	returner = true;
                }
            });
            return returner;
        }).remove();

        Object.keys(substitutes).forEach(function(cross) {
            var tmpNodes = [];
            dataNodes.forEach(function (dataNode) {
                if (substitutes[cross].indexOf(dataNode.id) == -1) {
                    tmpNodes.push(dataNode);
                }
            });
            var tmpIndex = tmpNodes.push({"name": "CROSS_"+cross, "type": "square", "id": "cross_" + cross, "size": substitutes[cross].length}) - 1;
            dataNodes = tmpNodes;

            var tmpLinks = [];
            dataLinks.forEach(function (dataLink) {
                if (crossesMapping[cross].indexOf(dataLink.source.index) == -1 && crossesMapping[cross].indexOf(dataLink.target.index) == -1) {
                    tmpLinks.push(dataLink);
                }
                if (crossesMapping[cross].indexOf(dataLink.source.index) > -1 && crossesMapping[cross].indexOf(dataLink.target.index) == -1) {
                    tmpLinks.push({"source":tmpIndex,"target":getNewIndexFromOriginal(dataLink.target.index),"weight":1, "value":20});
                    //tmpLinks.push(dataLink);
                }
                if (crossesMapping[cross].indexOf(dataLink.target.index) > -1 && crossesMapping[cross].indexOf(dataLink.source.index) == -1) {
                    tmpLinks.push({"source":getNewIndexFromOriginal(dataLink.source.index),"target":tmpIndex,"weight":1, "value":20});
                    //tmpLinks.push(dataLink);
                }
            });
            dataLinks = tmpLinks;
        });

        dataLinks.forEach(function(l) {
            console.log(l);
        });

        svg.selectAll(".node").remove();
        svg.selectAll(".link").remove();
        update();

	}

    //console.log(crosses);
    //console.log(crossesMapping);
    console.log("---END CROSS---");
}

function getNewIndexFromOriginal(index) {
    var originalNode = lastNodes[index];
    var originalNodeID = originalNode.id;
    //console.log(originalNode.name);
    var returner = -1;
    for (var i = 0; i < dataNodes.length; i++) {
        if (dataNodes[i].id == originalNodeID) {
            returner = i;
            break;
        }
    }
    return returner;
}

function calculateIntersections(a, b) {
    return a.filter(
        function(el) {
            return b.indexOf(el) >= 0;
        }
    );
}

function calculateDifferences(a, b) {
    return a.filter(
        function(el) {
            return b.indexOf(el) < 0;
        }
    );
}

function calculateMerge(a, b) {
	return a.concat(b.filter(
		function(el) {
			return a.indexOf(el) < 0;
		}
	));
}

function calculateCross(hit) {
	console.log("---CALCULATE CROSS---");
	var tmp = 0;
	for (var i = 2; tmp < hit; i++) {
		tmp = tmp + i;
		//console.log(tmp);
	}
	console.log("---CALCULATE CROSS END---");
	return tmp;
}

function reorganize() {
    reorganized = true;
    $('#reorganizeButton').attr("disabled", "disabled");

    if ($('input[name="optReorganize"]:checked').val() == 1) {
        highlightNodes = true;
    } else {
        highlightNodes = false;
    }
    var doEndpoints = false;
    var doMiddle = false;
    var doCross = false;

    var tmp = $('input[name="optReducing"]:checked');
    $.each(tmp, function (i, v) {
        if ($(tmp[i]).val() == 1) {
            doEndpoints = true;
        }
        if ($(tmp[i]).val() == 2) {
            doMiddle = true;
        }
        if ($(tmp[i]).val() == 3) {
            doCross = true;
        }
    });

    if (doEndpoints) {
        resetAll();
        prepareStructure();
        analyseStructure();
        handleEndPoints();
    }
    if (doCross) {
        resetAll();
        prepareStructure();
        analyseStructure();
        handleCross();
    }
    if (doMiddle) {
        resetAll();
        prepareStructure();
        analyseStructure();
        handleMiddle();
    }
    outputAll();
}

function outputAll() {
    outputNodes();
    outputLinks();
    outputLinkCodeIntersectionPlusCode();
}

function outputNodes() {
	svg.selectAll(".node").each(function(n) {console.log(n)});
}

function outputLinks() {
	console.log(linkCodes);
}

function outputLinkCodeIntersectionPlusCode() {
	console.log(linkCodeIntersectionPlusCodeMapping);
	console.log(intersectionPlusCodesMapping);
}

function update() {
    console.log("---UPDATE---");
    //console.log(dataNodes);
    //console.log(dataLinks);
    var showNodeNames = false;
    if ($('input[name="optNodeName"]:checked').length) {
        showNodeNames = true;
    }

    force
        .nodes(dataNodes)
        .links(dataLinks)
        .start();

    var link = svg.selectAll(".link")
        .data(dataLinks)
        .enter().append("line")
        .attr("class", "link")
        .style("stroke-width", function(d) { return Math.sqrt(d.weight); });

    var node = svg.selectAll(".node")
        .data(dataNodes)
        .enter().append("g")
        .attr("class", "node")
        .call(force.drag);

    node.filter(function(n) {
        if (n.type != "square" && n.type != "check" && n.type != "arc") {
            return true;
        } return false;
    }).append("circle")
        .attr("r", "10");

    var lineData = [
        { "x": -10,   "y": -10},  { "x": -5,  "y": -10},
        { "x": 0,   "y": 0},  { "x": 5,  "y": -10},
        { "x": 10,   "y": -10},  { "x": 0,  "y": 0},
        { "x": 10,   "y": 10},  { "x": 5,  "y": 10},
        { "x": 0,   "y": 0},  { "x": -5,  "y": 10},
        { "x": -10,   "y": 10},  { "x": 0,  "y": 0},
        { "x": -10,   "y": -10}
    ];
    var lineFunction = d3.svg.line().x(function(d) { return d.x; }).y(function(d) { return d.y; }).interpolate("linear");

    node.filter(function(n) {
        if (n.type == "square") {
            if (n.size) {
                var tmpLineData = [];
                lineData.forEach(function(data) {
                    data.x = data.x * n.size / n.size;
                    data.y = data.y * n.size / n.size;
                    tmpLineData.push(data);
                });
                lineData = tmpLineData;
            }
            return true;
        } return false;
    }).append("path")
        .attr("d", lineFunction(lineData))
        .attr("stroke", "blue")
        .attr("stroke-width", 2)
        .attr("fill", "blue")
        .on("mouseover", function(d) {
            doMouseOver(d);
        })
        .on("mouseout", function(d) {
            doMouseOut(d);
        });

    var lineData = [
        { "x": 0,   "y": -10},  { "x": 10,  "y": 0},
        { "x": 0,   "y": 10},  { "x": -10,  "y": 0},
        { "x": 0,   "y": -10}
    ];
    var lineFunction = d3.svg.line().x(function(d) { return d.x; }).y(function(d) { return d.y; }).interpolate("linear");

    node.filter(function(n) {
        if (n.type == "check") {
            var tmpLineData = [];
            lineData.forEach(function(data) {
                data.x = data.x * n.size / n.size;
                data.y = data.y * n.size / n.size;
                tmpLineData.push(data);
            });
            lineData = tmpLineData;
            return true;
        }
        return false;
    }).append("path")
        .attr("d", lineFunction(lineData))
        .attr("stroke", "red")
        .attr("stroke-width", 2)
        .attr("fill", "red")
        .on("mouseover", function(d) {
            doMouseOver(d);
        })
        .on("mouseout", function(d) {
            doMouseOut(d);
        });

    var arc =  d3.svg.arc()
        .innerRadius(0)
        .outerRadius(40)
        .startAngle(90 * (Math.PI/180)) //converting from degs to radians
        .endAngle(0);
    var arcWeight = 2;
    node.filter(function(n) {
        if (n.type == "arc") {
            if (n.size) {
                arc =  d3.svg.arc()
                    .innerRadius(0)
                    .outerRadius(40)
                    .startAngle(90 * (Math.PI/180)) //converting from degs to radians
                    .endAngle((90 - arcWeight * n.size + 45) * (Math.PI/180));
            }
            return true;
        } return false;
    }).append("path")
        .attr("d", arc)
        .attr("stroke", "green")
        .attr("stroke-width", 2)
        .attr("fill", "green")
        .on("mouseover", function(d) {
            doMouseOver(d);
        })
        .on("mouseout", function(d) {
            doMouseOut(d);
        });

    if (showNodeNames) {
        node.append("text")
            .attr("dx", 12)
            .attr("dy", ".35em")
            .text(function (d) {
                return d.name
            });
    }

    force.on("tick", function() {
        link.attr("x1", function(d) { return d.source.x; })
            .attr("y1", function(d) { return d.source.y; })
            .attr("x2", function(d) { return d.target.x; })
            .attr("y2", function(d) { return d.target.y; });

        node.attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; });
    });

}

function doMouseOver(d) {
    var backgroundColor = "";
    if (d.type == "square") {
        backgroundColor = "blue";
    }
    if (d.type == "arc") {
        backgroundColor = "green";
    }
    if (d.type == "check") {
        backgroundColor = "red";
    }

    var tmp = d3.select(".myToolTip");
    tmp.transition()
        .duration(200)
        .style("opacity", .9)
        .style("background-color", backgroundColor);
    tmp.html("");
}

function doMouseOut(d) {
    var tmp = d3.select(".myToolTip");
    tmp.transition()
        .duration(200)
        .style("opacity", 0);
    tmp.html("");
}

function loadData() {
    dataNodes = [];
    dataLinks = [];
    originalNodes = [];
    originalLinks = [];
    lastNodes = [];
    lastLinks = [];
    reorganized = false;
    highlightNodes = false;
    resetAll();
    svg.selectAll(".node").remove();
    svg.selectAll(".link").remove();

    $('#reorganizeButton').attr("disabled", false);

    var filename = "graphFile";
    if ($('input[name="optExample"]:checked').first()) {
        var tmp = $('input[name="optExample"]:checked').val();
        if (tmp == 1) {
            filename = "graphFile1";
        }
        if (tmp == 2) {
            filename = "graphFile2";
        }
        if (tmp == 3) {
            filename = "graphFile3";
        }
        if (tmp == 4) {
            filename = "network1";
        }
    }

    d3.json("./" + filename + ".json", function(json) {
        dataNodes = json.nodes;
        //console.log(json.nodes);
        originalNodes = json.nodes;
        dataLinks = json.links;
        originalLinks = json.links;
        update();
    });
}

function registerReorganizeSelect() {
    $('.reorganizeSelect').click(function (event) {
        console.log(event);
        if (this.value == 2) {
           $('.reduceSelect').attr("style", "display:block;");
        } else {
           $('.reduceSelect').attr("style", "display:none;");
        }
    });
}

function registerShowNodeNames() {
    $('input[name="optNodeName"]').click(function(event) {
        loadData();
    });
}

$(function() {
    registerReorganizeSelect();
    registerShowNodeNames();

    var width = $(window).width() - $("#left").width() - $("#right").width() - 100;
    var height = $(window).height() - 150;


	svg = d3.select("#visualisation").append("svg")
		.attr("width", width)
		.attr("height", height);

	force = d3.layout.force()
		.gravity(.05)
		.distance(100)
		.charge(-500)
		.size([width, height]);

    loadData();
});